Subject: Re: bug#8420: dirname

From: Bjartur Thorlacius <[email-masked]>
Date: Thu, 7 Apr 2011 16:48:14 +0000

On 4/5/11, Eric Blake <[email-masked]> wrote:
> On 04/05/2011 01:08 PM, Bjartur Thorlacius wrote:
>>> _mandates_ that any portable client software must be aware that
>>> extensions are permitted, and therefore the burden is on the client (and
>>> not on dirname itself) to supply the -- end-of-options argument if the
>>> operand starts with -.
>>>
>> True. I raised the issue as this wasn't clear from Open Groups'
>> document on dirname, and this argv format was incompatible with my
>> version of busybox.
>
> Umm, I _was_ quoting Open Group's formal document on dirname, which is
> why I'm quite confident that the bug is in busybox for not complying
> with the Open Group standard when it comes to -- handling.  But I will
> concede the fact that it can be a bit inconvenient that you have to read
> the section on global utility behavior, even if in the long run it makes
> more sense to have text just once in that global section than to
> duplicate global behavior descriptions into every utility page (even if
> too many people end up skipping over the global behavior pages).
>
>>> http://pubs.opengroup.org/onlinepubs/9699919799/utilities/V3_chap01.html#tag_17_04
>>>
>>> OPTIONS
>>> Default Behavior: When this section is listed as "None.", it means that
>>> the implementation need not support any options. Standard utilities that
>>> do not accept options, but that do accept operands, shall recognize "--"
>>> as a first argument to be discarded.
>>>
>> Thanks. I expected to see explicit references to documents such as
>> this one in a formal standard, but I guess I need to lie down and read
>> it in its entirety.
>
> That link is the Open Group's online version of IEEE Std 1003.1-2008
> (aka POSIX 2008, which in turn is included by reference in SUSv4); if
> you have the pdf of the Open Group standard, I was quoting from XCU 1.4,
> page 2288, lines 71982-71992.  Since dirname states "OPTIONS None." at
> page 2608 line 84080 later in the same document, the global handling
> applies to dirname.  Contrast that with the wording for echo at line 84301:
>
Yeah, it clearly applies. I'm simply spoiled by other standards groups
putting explicit references to dependancies into every document. HTML5
states that elements may have 'global attributes' when that applies,
even in the single file version. Heck RFCs reference RFC 2119
[http://www.ietf.org/rfc/rfc2119.txt] to clarify what terminology
they're using. The document I read can clearly not be considered
standalone.